/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2VectorElementwiseEpsilonP0Viscosity.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonP0Viscosity::computeInverseDiagonalOperatorValues_P2VectorElementwiseEpsilonP0Viscosity_macro_2D( real_t * RESTRICT  _data_invDiag__edge_0, real_t * RESTRICT  _data_invDiag__edge_1, real_t * RESTRICT  _data_invDiag__vertex_0, real_t * RESTRICT  _data_invDiag__vertex_1, real_t * RESTRICT  _data_mu, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       {
          /* FaceType.GRAY */
          const real_t _data_phi_0_0_GRAY [] = {1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GRAY [] = {((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*5.5555555555555545 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*2.7777777777777772 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*5.5555555555555545 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*2.7777777777777772 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.22222222222222227 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GRAY[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 13];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 25];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 38];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 51];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 64];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 77];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 88];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 98];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 111];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 124];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 137];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             const real_t elMatDiag_10 = q_acc_10_10;
             const real_t elMatDiag_11 = q_acc_11_11;
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_3 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_6 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_7 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_8 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_9 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_10 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))] = elMatDiag_11 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       {
          /* FaceType.BLUE */
          const real_t _data_phi_0_0_BLUE [] = {1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE [] = {((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*5.5555555555555545 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*2.7777777777777772 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*5.5555555555555545 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*2.7777777777777772 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.22222222222222227 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 13];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 25];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 38];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 51];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 64];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 77];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 88];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 98];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 111];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 124];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 137];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             const real_t elMatDiag_10 = q_acc_10_10;
             const real_t elMatDiag_11 = q_acc_11_11;
             _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_0 + _data_invDiag__vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_1 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatDiag_2 + _data_invDiag__vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_3 + _data_invDiag__edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatDiag_4 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_5 + _data_invDiag__edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1] = elMatDiag_6 + _data_invDiag__vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_7 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1] = elMatDiag_8 + _data_invDiag__vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1];
             _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))] = elMatDiag_9 + _data_invDiag__edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1] = elMatDiag_10 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1];
             _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))] = elMatDiag_11 + _data_invDiag__edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
