/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2VectorElementwiseEpsilonP0Viscosity.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2VectorElementwiseEpsilonP0Viscosity::toMatrix_P2VectorElementwiseEpsilonP0Viscosity_macro_2D( idx_t * RESTRICT  _data_dst_edge_0, idx_t * RESTRICT  _data_dst_edge_1, idx_t * RESTRICT  _data_dst_vertex_0, idx_t * RESTRICT  _data_dst_vertex_1, real_t * RESTRICT  _data_mu, idx_t * RESTRICT  _data_src_edge_0, idx_t * RESTRICT  _data_src_edge_1, idx_t * RESTRICT  _data_src_vertex_0, idx_t * RESTRICT  _data_src_vertex_1, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.16666666666666666, 0.16666666666666666, 0.16666666666666666};
   
       const real_t tmp_coords_jac_0_GRAY = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_GRAY = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_GRAY = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_1_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_2_0_GRAY = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_GRAY = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GRAY*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t jac_affine_0_0_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_1_0_GRAY;
       const real_t jac_affine_0_1_GRAY = -p_affine_const_0_0_GRAY + p_affine_const_2_0_GRAY;
       const real_t jac_affine_1_0_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_1_1_GRAY;
       const real_t jac_affine_1_1_GRAY = -p_affine_const_0_1_GRAY + p_affine_const_2_1_GRAY;
       const real_t tmp_coords_jac_1_GRAY = jac_affine_0_0_GRAY*jac_affine_1_1_GRAY - jac_affine_0_1_GRAY*jac_affine_1_0_GRAY;
       const real_t tmp_coords_jac_2_GRAY = 1.0 / (tmp_coords_jac_1_GRAY);
       const real_t jac_affine_inv_0_0_GRAY = jac_affine_1_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_0_1_GRAY = -jac_affine_0_1_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_0_GRAY = -jac_affine_1_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t jac_affine_inv_1_1_GRAY = jac_affine_0_0_GRAY*tmp_coords_jac_2_GRAY;
       const real_t abs_det_jac_affine_GRAY = abs(tmp_coords_jac_1_GRAY);
       {
          /* FaceType.GRAY */
          const real_t _data_phi_0_0_GRAY [] = {1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_GRAY [] = {((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.16666666666666652 + jac_affine_inv_1_1_GRAY*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*5.5555555555555545 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666607 + jac_affine_inv_1_0_GRAY*0.66666666666666607)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*5.333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-5.333333333333333 + jac_affine_inv_1_0_GRAY*-3.9999999999999991)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666652 + jac_affine_inv_1_0_GRAY*0.16666666666666652)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*2.7777777777777772 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*-0.99999999999999978)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.33333333333333304 + jac_affine_inv_1_1_GRAY*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.6666666666666665 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-2.6666666666666665 + jac_affine_inv_1_1_GRAY*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333304 + jac_affine_inv_1_0_GRAY*0.33333333333333304)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666607 + jac_affine_inv_1_1_GRAY*0.66666666666666607)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.6666666666666665 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*5.333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-2.6666666666666665 + jac_affine_inv_1_0_GRAY*-1.9999999999999996)*(jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-5.333333333333333 + jac_affine_inv_1_1_GRAY*-3.9999999999999991)*(jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.2204460492503131e-16 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*4.4408920985006262e-16 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*8.8817841970012523e-16 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.16666666666666657 + jac_affine_inv_1_1_GRAY*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*5.5555555555555545 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-1.1111111111111112 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*2.7777777777777772)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.6666666666666663 + jac_affine_inv_1_0_GRAY*0.6666666666666663) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*-3.9999999999999991 + jac_affine_inv_1_0_GRAY*-5.333333333333333) + (jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-0.99999999999999978 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.16666666666666657 + jac_affine_inv_1_0_GRAY*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*2.7777777777777772 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*-0.55555555555555558 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*2.2204460492503131e-16)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.33333333333333315 + jac_affine_inv_1_1_GRAY*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.33333333333333315 + jac_affine_inv_1_0_GRAY*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*0.6666666666666663 + jac_affine_inv_1_1_GRAY*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*4.4408920985006262e-16)*(jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*8.8817841970012523e-16)*(jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.99999999999999978 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*(jac_affine_inv_0_0_GRAY*-1.9999999999999996 + jac_affine_inv_1_0_GRAY*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_GRAY*-1.9999999999999996 + jac_affine_inv_1_1_GRAY*-2.6666666666666665)*(jac_affine_inv_0_1_GRAY*-3.9999999999999991 + jac_affine_inv_1_1_GRAY*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.83333333333333348 + jac_affine_inv_1_1_GRAY*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.22222222222222227 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.22222222222222227 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_0_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.22222222222222227 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*jac_affine_inv_1_1_GRAY*0.11111111111111113)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*0.33333333333333331 + jac_affine_inv_1_1_GRAY*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*-0.33333333333333331 + jac_affine_inv_1_1_GRAY*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-3.3333333333333339 + jac_affine_inv_1_0_GRAY*-3.3333333333333339)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.3333333333333333 + jac_affine_inv_1_0_GRAY*1.3333333333333333)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.3333333333333333 + jac_affine_inv_1_0_GRAY*4.0000000000000009)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663) + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_0_GRAY*4.0000000000000009 + jac_affine_inv_1_0_GRAY*-1.3333333333333333) + (jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.0000000000000002 + jac_affine_inv_1_1_GRAY*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.83333333333333348 + jac_affine_inv_1_0_GRAY*-0.83333333333333348)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*jac_affine_inv_0_0_GRAY)*0.11111111111111113 + (jac_affine_inv_0_1_GRAY*jac_affine_inv_0_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*jac_affine_inv_1_0_GRAY*0.11111111111111113 + jac_affine_inv_0_1_GRAY*jac_affine_inv_1_1_GRAY*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_1_0_GRAY*jac_affine_inv_1_0_GRAY)*0.11111111111111113 + (jac_affine_inv_1_1_GRAY*jac_affine_inv_1_1_GRAY)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.33333333333333331 + jac_affine_inv_1_0_GRAY*0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.33333333333333331 + jac_affine_inv_1_0_GRAY*1.0000000000000002)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-1.666666666666667 + jac_affine_inv_1_1_GRAY*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*0.66666666666666663 + jac_affine_inv_1_1_GRAY*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*-0.66666666666666663 + jac_affine_inv_1_1_GRAY*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-1.666666666666667 + jac_affine_inv_1_0_GRAY*-1.666666666666667)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-3.3333333333333339 + jac_affine_inv_1_1_GRAY*-3.3333333333333339)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_0_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*(jac_affine_inv_1_0_GRAY*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_GRAY*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*0.66666666666666663 + jac_affine_inv_1_0_GRAY*0.66666666666666663)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*1.3333333333333333 + jac_affine_inv_1_1_GRAY*1.3333333333333333)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*-0.66666666666666663 + jac_affine_inv_1_0_GRAY*2.0000000000000004)*(jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_GRAY*-1.3333333333333333 + jac_affine_inv_1_1_GRAY*4.0000000000000009)*(jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_GRAY*((jac_affine_inv_0_0_GRAY*1.0000000000000002 + jac_affine_inv_1_0_GRAY*-0.33333333333333331)*(jac_affine_inv_0_0_GRAY*2.0000000000000004 + jac_affine_inv_1_0_GRAY*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_GRAY*2.0000000000000004 + jac_affine_inv_1_1_GRAY*-0.66666666666666663)*(jac_affine_inv_0_1_GRAY*4.0000000000000009 + jac_affine_inv_1_1_GRAY*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_GRAY[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 11];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 13];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 14];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 15];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 16];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 17];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 18];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 19];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 20];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 21];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 22];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 23];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 25];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 26];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 27];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 28];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 29];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 30];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 31];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 32];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 33];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 34];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 38];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 39];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 40];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 41];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 42];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 43];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 44];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 45];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 46];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 51];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 52];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 53];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 54];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 55];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 56];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 57];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 58];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 64];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 65];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 66];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 67];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 68];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 69];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 70];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 77];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 78];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 79];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 80];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 81];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 82];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 88];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 89];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 90];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 91];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 92];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 98];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 99];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 100];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 101];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 111];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 112];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 113];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 124];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 125];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_GRAY[138*q + 137];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
         
             std::vector< uint_t > _data_rowIdx( 12 );
             std::vector< uint_t > _data_colIdx( 12 );
             std::vector< real_t > _data_mat( 144 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[3] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2))]));
             _data_colIdx[7] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[11] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_1_0));
             _data_mat[13] = ((real_t)(elMat_1_1));
             _data_mat[14] = ((real_t)(elMat_1_2));
             _data_mat[15] = ((real_t)(elMat_1_3));
             _data_mat[16] = ((real_t)(elMat_1_4));
             _data_mat[17] = ((real_t)(elMat_1_5));
             _data_mat[18] = ((real_t)(elMat_1_6));
             _data_mat[19] = ((real_t)(elMat_1_7));
             _data_mat[20] = ((real_t)(elMat_1_8));
             _data_mat[21] = ((real_t)(elMat_1_9));
             _data_mat[22] = ((real_t)(elMat_1_10));
             _data_mat[23] = ((real_t)(elMat_1_11));
             _data_mat[24] = ((real_t)(elMat_2_0));
             _data_mat[25] = ((real_t)(elMat_2_1));
             _data_mat[26] = ((real_t)(elMat_2_2));
             _data_mat[27] = ((real_t)(elMat_2_3));
             _data_mat[28] = ((real_t)(elMat_2_4));
             _data_mat[29] = ((real_t)(elMat_2_5));
             _data_mat[30] = ((real_t)(elMat_2_6));
             _data_mat[31] = ((real_t)(elMat_2_7));
             _data_mat[32] = ((real_t)(elMat_2_8));
             _data_mat[33] = ((real_t)(elMat_2_9));
             _data_mat[34] = ((real_t)(elMat_2_10));
             _data_mat[35] = ((real_t)(elMat_2_11));
             _data_mat[36] = ((real_t)(elMat_3_0));
             _data_mat[37] = ((real_t)(elMat_3_1));
             _data_mat[38] = ((real_t)(elMat_3_2));
             _data_mat[39] = ((real_t)(elMat_3_3));
             _data_mat[40] = ((real_t)(elMat_3_4));
             _data_mat[41] = ((real_t)(elMat_3_5));
             _data_mat[42] = ((real_t)(elMat_3_6));
             _data_mat[43] = ((real_t)(elMat_3_7));
             _data_mat[44] = ((real_t)(elMat_3_8));
             _data_mat[45] = ((real_t)(elMat_3_9));
             _data_mat[46] = ((real_t)(elMat_3_10));
             _data_mat[47] = ((real_t)(elMat_3_11));
             _data_mat[48] = ((real_t)(elMat_4_0));
             _data_mat[49] = ((real_t)(elMat_4_1));
             _data_mat[50] = ((real_t)(elMat_4_2));
             _data_mat[51] = ((real_t)(elMat_4_3));
             _data_mat[52] = ((real_t)(elMat_4_4));
             _data_mat[53] = ((real_t)(elMat_4_5));
             _data_mat[54] = ((real_t)(elMat_4_6));
             _data_mat[55] = ((real_t)(elMat_4_7));
             _data_mat[56] = ((real_t)(elMat_4_8));
             _data_mat[57] = ((real_t)(elMat_4_9));
             _data_mat[58] = ((real_t)(elMat_4_10));
             _data_mat[59] = ((real_t)(elMat_4_11));
             _data_mat[60] = ((real_t)(elMat_5_0));
             _data_mat[61] = ((real_t)(elMat_5_1));
             _data_mat[62] = ((real_t)(elMat_5_2));
             _data_mat[63] = ((real_t)(elMat_5_3));
             _data_mat[64] = ((real_t)(elMat_5_4));
             _data_mat[65] = ((real_t)(elMat_5_5));
             _data_mat[66] = ((real_t)(elMat_5_6));
             _data_mat[67] = ((real_t)(elMat_5_7));
             _data_mat[68] = ((real_t)(elMat_5_8));
             _data_mat[69] = ((real_t)(elMat_5_9));
             _data_mat[70] = ((real_t)(elMat_5_10));
             _data_mat[71] = ((real_t)(elMat_5_11));
             _data_mat[72] = ((real_t)(elMat_6_0));
             _data_mat[73] = ((real_t)(elMat_6_1));
             _data_mat[74] = ((real_t)(elMat_6_2));
             _data_mat[75] = ((real_t)(elMat_6_3));
             _data_mat[76] = ((real_t)(elMat_6_4));
             _data_mat[77] = ((real_t)(elMat_6_5));
             _data_mat[78] = ((real_t)(elMat_6_6));
             _data_mat[79] = ((real_t)(elMat_6_7));
             _data_mat[80] = ((real_t)(elMat_6_8));
             _data_mat[81] = ((real_t)(elMat_6_9));
             _data_mat[82] = ((real_t)(elMat_6_10));
             _data_mat[83] = ((real_t)(elMat_6_11));
             _data_mat[84] = ((real_t)(elMat_7_0));
             _data_mat[85] = ((real_t)(elMat_7_1));
             _data_mat[86] = ((real_t)(elMat_7_2));
             _data_mat[87] = ((real_t)(elMat_7_3));
             _data_mat[88] = ((real_t)(elMat_7_4));
             _data_mat[89] = ((real_t)(elMat_7_5));
             _data_mat[90] = ((real_t)(elMat_7_6));
             _data_mat[91] = ((real_t)(elMat_7_7));
             _data_mat[92] = ((real_t)(elMat_7_8));
             _data_mat[93] = ((real_t)(elMat_7_9));
             _data_mat[94] = ((real_t)(elMat_7_10));
             _data_mat[95] = ((real_t)(elMat_7_11));
             _data_mat[96] = ((real_t)(elMat_8_0));
             _data_mat[97] = ((real_t)(elMat_8_1));
             _data_mat[98] = ((real_t)(elMat_8_2));
             _data_mat[99] = ((real_t)(elMat_8_3));
             _data_mat[100] = ((real_t)(elMat_8_4));
             _data_mat[101] = ((real_t)(elMat_8_5));
             _data_mat[102] = ((real_t)(elMat_8_6));
             _data_mat[103] = ((real_t)(elMat_8_7));
             _data_mat[104] = ((real_t)(elMat_8_8));
             _data_mat[105] = ((real_t)(elMat_8_9));
             _data_mat[106] = ((real_t)(elMat_8_10));
             _data_mat[107] = ((real_t)(elMat_8_11));
             _data_mat[108] = ((real_t)(elMat_9_0));
             _data_mat[109] = ((real_t)(elMat_9_1));
             _data_mat[110] = ((real_t)(elMat_9_2));
             _data_mat[111] = ((real_t)(elMat_9_3));
             _data_mat[112] = ((real_t)(elMat_9_4));
             _data_mat[113] = ((real_t)(elMat_9_5));
             _data_mat[114] = ((real_t)(elMat_9_6));
             _data_mat[115] = ((real_t)(elMat_9_7));
             _data_mat[116] = ((real_t)(elMat_9_8));
             _data_mat[117] = ((real_t)(elMat_9_9));
             _data_mat[118] = ((real_t)(elMat_9_10));
             _data_mat[119] = ((real_t)(elMat_9_11));
             _data_mat[120] = ((real_t)(elMat_10_0));
             _data_mat[121] = ((real_t)(elMat_10_1));
             _data_mat[122] = ((real_t)(elMat_10_2));
             _data_mat[123] = ((real_t)(elMat_10_3));
             _data_mat[124] = ((real_t)(elMat_10_4));
             _data_mat[125] = ((real_t)(elMat_10_5));
             _data_mat[126] = ((real_t)(elMat_10_6));
             _data_mat[127] = ((real_t)(elMat_10_7));
             _data_mat[128] = ((real_t)(elMat_10_8));
             _data_mat[129] = ((real_t)(elMat_10_9));
             _data_mat[130] = ((real_t)(elMat_10_10));
             _data_mat[131] = ((real_t)(elMat_10_11));
             _data_mat[132] = ((real_t)(elMat_11_0));
             _data_mat[133] = ((real_t)(elMat_11_1));
             _data_mat[134] = ((real_t)(elMat_11_2));
             _data_mat[135] = ((real_t)(elMat_11_3));
             _data_mat[136] = ((real_t)(elMat_11_4));
             _data_mat[137] = ((real_t)(elMat_11_5));
             _data_mat[138] = ((real_t)(elMat_11_6));
             _data_mat[139] = ((real_t)(elMat_11_7));
             _data_mat[140] = ((real_t)(elMat_11_8));
             _data_mat[141] = ((real_t)(elMat_11_9));
             _data_mat[142] = ((real_t)(elMat_11_10));
             _data_mat[143] = ((real_t)(elMat_11_11));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const real_t tmp_coords_jac_0_BLUE = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_4_BLUE = tmp_coords_jac_0_BLUE*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_0_0_BLUE = tmp_coords_jac_1_BLUE;
       const real_t p_affine_const_0_1_BLUE = tmp_coords_jac_2_BLUE;
       const real_t p_affine_const_1_0_BLUE = macro_vertex_coord_id_0comp0 + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_1_1_BLUE = macro_vertex_coord_id_0comp1 + tmp_coords_jac_4_BLUE;
       const real_t p_affine_const_2_0_BLUE = tmp_coords_jac_1_BLUE + tmp_coords_jac_3_BLUE;
       const real_t p_affine_const_2_1_BLUE = tmp_coords_jac_2_BLUE + tmp_coords_jac_4_BLUE;
       const real_t jac_affine_0_0_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_1_0_BLUE;
       const real_t jac_affine_0_1_BLUE = -p_affine_const_0_0_BLUE + p_affine_const_2_0_BLUE;
       const real_t jac_affine_1_0_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_1_1_BLUE;
       const real_t jac_affine_1_1_BLUE = -p_affine_const_0_1_BLUE + p_affine_const_2_1_BLUE;
       const real_t tmp_coords_jac_5_BLUE = jac_affine_0_0_BLUE*jac_affine_1_1_BLUE - jac_affine_0_1_BLUE*jac_affine_1_0_BLUE;
       const real_t tmp_coords_jac_6_BLUE = 1.0 / (tmp_coords_jac_5_BLUE);
       const real_t jac_affine_inv_0_0_BLUE = jac_affine_1_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_0_1_BLUE = -jac_affine_0_1_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_0_BLUE = -jac_affine_1_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t jac_affine_inv_1_1_BLUE = jac_affine_0_0_BLUE*tmp_coords_jac_6_BLUE;
       const real_t abs_det_jac_affine_BLUE = abs(tmp_coords_jac_5_BLUE);
       {
          /* FaceType.BLUE */
          const real_t _data_phi_0_0_BLUE [] = {1.0, 1.0, 1.0};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE [] = {((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.16666666666666652 + jac_affine_inv_1_1_BLUE*0.16666666666666652)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*5.5555555555555545 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*-0.99999999999999978)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666607 + jac_affine_inv_1_0_BLUE*0.66666666666666607)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*5.333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-5.333333333333333 + jac_affine_inv_1_0_BLUE*-3.9999999999999991)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666652 + jac_affine_inv_1_0_BLUE*0.16666666666666652)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*2.7777777777777772 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*1.6666666666666665 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*-0.99999999999999978)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.33333333333333304 + jac_affine_inv_1_1_BLUE*0.33333333333333304)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.6666666666666665 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-2.6666666666666665 + jac_affine_inv_1_1_BLUE*-1.9999999999999996)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333304 + jac_affine_inv_1_0_BLUE*0.33333333333333304)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666607 + jac_affine_inv_1_1_BLUE*0.66666666666666607)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*3.333333333333333 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.6666666666666665 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*5.333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-2.6666666666666665 + jac_affine_inv_1_0_BLUE*-1.9999999999999996)*(jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-5.333333333333333 + jac_affine_inv_1_1_BLUE*-3.9999999999999991)*(jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*4.4408920985006262e-16 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*8.8817841970012523e-16 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.16666666666666657 + jac_affine_inv_1_1_BLUE*0.16666666666666657)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*5.5555555555555545 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*2.7777777777777772))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-1.1111111111111112 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*2.7777777777777772)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*-0.55555555555555558)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*2.2204460492503131e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.6666666666666663 + jac_affine_inv_1_0_BLUE*0.6666666666666663) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*-3.9999999999999991 + jac_affine_inv_1_0_BLUE*-5.333333333333333) + (jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-0.99999999999999978 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.16666666666666657 + jac_affine_inv_1_0_BLUE*0.16666666666666657)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*1.6666666666666665)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*2.7777777777777772 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*5.5555555555555545))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*-0.55555555555555558 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*-1.1111111111111112))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*1.6666666666666665 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*1.6666666666666665))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*2.2204460492503131e-16)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.33333333333333315 + jac_affine_inv_1_1_BLUE*0.33333333333333315)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*4.4408920985006262e-16)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.33333333333333315 + jac_affine_inv_1_0_BLUE*0.33333333333333315)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*0.6666666666666663 + jac_affine_inv_1_1_BLUE*0.6666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*3.333333333333333 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*3.333333333333333))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*4.4408920985006262e-16)*(jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*8.8817841970012523e-16)*(jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.99999999999999978 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*(jac_affine_inv_0_0_BLUE*-1.9999999999999996 + jac_affine_inv_1_0_BLUE*-2.6666666666666665)*2.0 + (jac_affine_inv_0_1_BLUE*-1.9999999999999996 + jac_affine_inv_1_1_BLUE*-2.6666666666666665)*(jac_affine_inv_0_1_BLUE*-3.9999999999999991 + jac_affine_inv_1_1_BLUE*-5.333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.83333333333333348 + jac_affine_inv_1_1_BLUE*-0.83333333333333348)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.22222222222222227 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.22222222222222227 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_0_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.22222222222222227 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.11111111111111113))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*jac_affine_inv_1_1_BLUE*0.11111111111111113)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*0.33333333333333331 + jac_affine_inv_1_1_BLUE*0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*-0.33333333333333331 + jac_affine_inv_1_1_BLUE*1.0000000000000002)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-3.3333333333333339 + jac_affine_inv_1_0_BLUE*-3.3333333333333339)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.3333333333333333 + jac_affine_inv_1_0_BLUE*1.3333333333333333)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.3333333333333333 + jac_affine_inv_1_0_BLUE*4.0000000000000009)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663) + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_0_BLUE*4.0000000000000009 + jac_affine_inv_1_0_BLUE*-1.3333333333333333) + (jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.0000000000000002 + jac_affine_inv_1_1_BLUE*-0.33333333333333331)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.83333333333333348 + jac_affine_inv_1_0_BLUE*-0.83333333333333348)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*jac_affine_inv_0_0_BLUE)*0.11111111111111113 + (jac_affine_inv_0_1_BLUE*jac_affine_inv_0_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*jac_affine_inv_1_0_BLUE*0.11111111111111113 + jac_affine_inv_0_1_BLUE*jac_affine_inv_1_1_BLUE*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.33333333333333337)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_1_0_BLUE*jac_affine_inv_1_0_BLUE)*0.11111111111111113 + (jac_affine_inv_1_1_BLUE*jac_affine_inv_1_1_BLUE)*0.22222222222222227))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*-0.33333333333333337 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)*-0.33333333333333337))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.33333333333333331 + jac_affine_inv_1_0_BLUE*0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.33333333333333331 + jac_affine_inv_1_0_BLUE*1.0000000000000002)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-1.666666666666667 + jac_affine_inv_1_1_BLUE*-1.666666666666667)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*0.66666666666666663 + jac_affine_inv_1_1_BLUE*0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*-0.66666666666666663 + jac_affine_inv_1_1_BLUE*2.0000000000000004)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*2.0)), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-1.666666666666667 + jac_affine_inv_1_0_BLUE*-1.666666666666667)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-3.3333333333333339 + jac_affine_inv_1_1_BLUE*-3.3333333333333339)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_0_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_0_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*(jac_affine_inv_1_0_BLUE*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*-0.66666666666666674 + jac_affine_inv_1_1_BLUE*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*-0.66666666666666674))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*0.66666666666666663 + jac_affine_inv_1_0_BLUE*0.66666666666666663)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*1.3333333333333333 + jac_affine_inv_1_1_BLUE*1.3333333333333333)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*-0.66666666666666663 + jac_affine_inv_1_0_BLUE*2.0000000000000004)*(jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*2.0 + (jac_affine_inv_0_1_BLUE*-1.3333333333333333 + jac_affine_inv_1_1_BLUE*4.0000000000000009)*(jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)))), ((real_t)(abs_det_jac_affine_BLUE*((jac_affine_inv_0_0_BLUE*1.0000000000000002 + jac_affine_inv_1_0_BLUE*-0.33333333333333331)*(jac_affine_inv_0_0_BLUE*2.0000000000000004 + jac_affine_inv_1_0_BLUE*-0.66666666666666663)*2.0 + (jac_affine_inv_0_1_BLUE*2.0000000000000004 + jac_affine_inv_1_1_BLUE*-0.66666666666666663)*(jac_affine_inv_0_1_BLUE*4.0000000000000009 + jac_affine_inv_1_1_BLUE*-1.3333333333333333))))};
      
          for (int64_t ctr_1 = 0; ctr_1 < micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_mu[ctr_0 + ctr_1*micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_0_10 = 0.0;
             real_t q_acc_0_11 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_1_10 = 0.0;
             real_t q_acc_1_11 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_2_10 = 0.0;
             real_t q_acc_2_11 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             real_t q_acc_3_10 = 0.0;
             real_t q_acc_3_11 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_4_5 = 0.0;
             real_t q_acc_4_6 = 0.0;
             real_t q_acc_4_7 = 0.0;
             real_t q_acc_4_8 = 0.0;
             real_t q_acc_4_9 = 0.0;
             real_t q_acc_4_10 = 0.0;
             real_t q_acc_4_11 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_5_6 = 0.0;
             real_t q_acc_5_7 = 0.0;
             real_t q_acc_5_8 = 0.0;
             real_t q_acc_5_9 = 0.0;
             real_t q_acc_5_10 = 0.0;
             real_t q_acc_5_11 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_6_7 = 0.0;
             real_t q_acc_6_8 = 0.0;
             real_t q_acc_6_9 = 0.0;
             real_t q_acc_6_10 = 0.0;
             real_t q_acc_6_11 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_7_8 = 0.0;
             real_t q_acc_7_9 = 0.0;
             real_t q_acc_7_10 = 0.0;
             real_t q_acc_7_11 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_8_9 = 0.0;
             real_t q_acc_8_10 = 0.0;
             real_t q_acc_8_11 = 0.0;
             real_t q_acc_9_9 = 0.0;
             real_t q_acc_9_10 = 0.0;
             real_t q_acc_9_11 = 0.0;
             real_t q_acc_10_10 = 0.0;
             real_t q_acc_10_11 = 0.0;
             real_t q_acc_11_11 = 0.0;
             for (int64_t q = 0; q < 3; q += 1)
             {
                const real_t tmp_qloop_0 = mu_dof_0*_data_phi_0_0_BLUE[q]*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q];
                const real_t q_tmp_0_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 9];
                const real_t q_tmp_0_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 10];
                const real_t q_tmp_0_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 11];
                const real_t q_tmp_1_1 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 13];
                const real_t q_tmp_1_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 14];
                const real_t q_tmp_1_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 15];
                const real_t q_tmp_1_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 16];
                const real_t q_tmp_1_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 17];
                const real_t q_tmp_1_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 18];
                const real_t q_tmp_1_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 19];
                const real_t q_tmp_1_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 20];
                const real_t q_tmp_1_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 21];
                const real_t q_tmp_1_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 22];
                const real_t q_tmp_1_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 23];
                const real_t q_tmp_2_2 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 25];
                const real_t q_tmp_2_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 26];
                const real_t q_tmp_2_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 27];
                const real_t q_tmp_2_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 28];
                const real_t q_tmp_2_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 29];
                const real_t q_tmp_2_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 30];
                const real_t q_tmp_2_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 31];
                const real_t q_tmp_2_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 32];
                const real_t q_tmp_2_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 33];
                const real_t q_tmp_2_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 34];
                const real_t q_tmp_3_3 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 38];
                const real_t q_tmp_3_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 39];
                const real_t q_tmp_3_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 40];
                const real_t q_tmp_3_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 41];
                const real_t q_tmp_3_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 42];
                const real_t q_tmp_3_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 43];
                const real_t q_tmp_3_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 44];
                const real_t q_tmp_3_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 45];
                const real_t q_tmp_3_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 46];
                const real_t q_tmp_4_4 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 51];
                const real_t q_tmp_4_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 52];
                const real_t q_tmp_4_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 53];
                const real_t q_tmp_4_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 54];
                const real_t q_tmp_4_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 55];
                const real_t q_tmp_4_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 56];
                const real_t q_tmp_4_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 57];
                const real_t q_tmp_4_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 58];
                const real_t q_tmp_5_5 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 64];
                const real_t q_tmp_5_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 65];
                const real_t q_tmp_5_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 66];
                const real_t q_tmp_5_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 67];
                const real_t q_tmp_5_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 68];
                const real_t q_tmp_5_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 69];
                const real_t q_tmp_5_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 70];
                const real_t q_tmp_6_6 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 77];
                const real_t q_tmp_6_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 78];
                const real_t q_tmp_6_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 79];
                const real_t q_tmp_6_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 80];
                const real_t q_tmp_6_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 81];
                const real_t q_tmp_6_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 82];
                const real_t q_tmp_7_7 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 88];
                const real_t q_tmp_7_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 89];
                const real_t q_tmp_7_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 90];
                const real_t q_tmp_7_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 91];
                const real_t q_tmp_7_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 92];
                const real_t q_tmp_8_8 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 98];
                const real_t q_tmp_8_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 99];
                const real_t q_tmp_8_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 100];
                const real_t q_tmp_8_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 101];
                const real_t q_tmp_9_9 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 111];
                const real_t q_tmp_9_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 112];
                const real_t q_tmp_9_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 113];
                const real_t q_tmp_10_10 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 124];
                const real_t q_tmp_10_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 125];
                const real_t q_tmp_11_11 = tmp_qloop_0*_data_tabulated_and_untitled_0_0_BLUE[138*q + 137];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_0_10 = q_acc_0_10 + q_tmp_0_10;
                q_acc_0_11 = q_acc_0_11 + q_tmp_0_11;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_1_10 = q_acc_1_10 + q_tmp_1_10;
                q_acc_1_11 = q_acc_1_11 + q_tmp_1_11;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_2_10 = q_acc_2_10 + q_tmp_2_10;
                q_acc_2_11 = q_acc_2_11 + q_tmp_2_11;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_3_10 = q_acc_3_10 + q_tmp_3_10;
                q_acc_3_11 = q_acc_3_11 + q_tmp_3_11;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_4_10 = q_acc_4_10 + q_tmp_4_10;
                q_acc_4_11 = q_acc_4_11 + q_tmp_4_11;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_5_10 = q_acc_5_10 + q_tmp_5_10;
                q_acc_5_11 = q_acc_5_11 + q_tmp_5_11;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_6_10 = q_acc_6_10 + q_tmp_6_10;
                q_acc_6_11 = q_acc_6_11 + q_tmp_6_11;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_7_10 = q_acc_7_10 + q_tmp_7_10;
                q_acc_7_11 = q_acc_7_11 + q_tmp_7_11;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_8_10 = q_acc_8_10 + q_tmp_8_10;
                q_acc_8_11 = q_acc_8_11 + q_tmp_8_11;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
                q_acc_9_10 = q_acc_9_10 + q_tmp_9_10;
                q_acc_9_11 = q_acc_9_11 + q_tmp_9_11;
                q_acc_10_10 = q_acc_10_10 + q_tmp_10_10;
                q_acc_10_11 = q_acc_10_11 + q_tmp_10_11;
                q_acc_11_11 = q_acc_11_11 + q_tmp_11_11;
             }
             const real_t elMat_0_0 = q_acc_0_0;
             const real_t elMat_0_1 = q_acc_0_1;
             const real_t elMat_0_2 = q_acc_0_2;
             const real_t elMat_0_3 = q_acc_0_3;
             const real_t elMat_0_4 = q_acc_0_4;
             const real_t elMat_0_5 = q_acc_0_5;
             const real_t elMat_0_6 = q_acc_0_6;
             const real_t elMat_0_7 = q_acc_0_7;
             const real_t elMat_0_8 = q_acc_0_8;
             const real_t elMat_0_9 = q_acc_0_9;
             const real_t elMat_0_10 = q_acc_0_10;
             const real_t elMat_0_11 = q_acc_0_11;
             const real_t elMat_1_0 = q_acc_0_1;
             const real_t elMat_1_1 = q_acc_1_1;
             const real_t elMat_1_2 = q_acc_1_2;
             const real_t elMat_1_3 = q_acc_1_3;
             const real_t elMat_1_4 = q_acc_1_4;
             const real_t elMat_1_5 = q_acc_1_5;
             const real_t elMat_1_6 = q_acc_1_6;
             const real_t elMat_1_7 = q_acc_1_7;
             const real_t elMat_1_8 = q_acc_1_8;
             const real_t elMat_1_9 = q_acc_1_9;
             const real_t elMat_1_10 = q_acc_1_10;
             const real_t elMat_1_11 = q_acc_1_11;
             const real_t elMat_2_0 = q_acc_0_2;
             const real_t elMat_2_1 = q_acc_1_2;
             const real_t elMat_2_2 = q_acc_2_2;
             const real_t elMat_2_3 = q_acc_2_3;
             const real_t elMat_2_4 = q_acc_2_4;
             const real_t elMat_2_5 = q_acc_2_5;
             const real_t elMat_2_6 = q_acc_2_6;
             const real_t elMat_2_7 = q_acc_2_7;
             const real_t elMat_2_8 = q_acc_2_8;
             const real_t elMat_2_9 = q_acc_2_9;
             const real_t elMat_2_10 = q_acc_2_10;
             const real_t elMat_2_11 = q_acc_2_11;
             const real_t elMat_3_0 = q_acc_0_3;
             const real_t elMat_3_1 = q_acc_1_3;
             const real_t elMat_3_2 = q_acc_2_3;
             const real_t elMat_3_3 = q_acc_3_3;
             const real_t elMat_3_4 = q_acc_3_4;
             const real_t elMat_3_5 = q_acc_3_5;
             const real_t elMat_3_6 = q_acc_3_6;
             const real_t elMat_3_7 = q_acc_3_7;
             const real_t elMat_3_8 = q_acc_3_8;
             const real_t elMat_3_9 = q_acc_3_9;
             const real_t elMat_3_10 = q_acc_3_10;
             const real_t elMat_3_11 = q_acc_3_11;
             const real_t elMat_4_0 = q_acc_0_4;
             const real_t elMat_4_1 = q_acc_1_4;
             const real_t elMat_4_2 = q_acc_2_4;
             const real_t elMat_4_3 = q_acc_3_4;
             const real_t elMat_4_4 = q_acc_4_4;
             const real_t elMat_4_5 = q_acc_4_5;
             const real_t elMat_4_6 = q_acc_4_6;
             const real_t elMat_4_7 = q_acc_4_7;
             const real_t elMat_4_8 = q_acc_4_8;
             const real_t elMat_4_9 = q_acc_4_9;
             const real_t elMat_4_10 = q_acc_4_10;
             const real_t elMat_4_11 = q_acc_4_11;
             const real_t elMat_5_0 = q_acc_0_5;
             const real_t elMat_5_1 = q_acc_1_5;
             const real_t elMat_5_2 = q_acc_2_5;
             const real_t elMat_5_3 = q_acc_3_5;
             const real_t elMat_5_4 = q_acc_4_5;
             const real_t elMat_5_5 = q_acc_5_5;
             const real_t elMat_5_6 = q_acc_5_6;
             const real_t elMat_5_7 = q_acc_5_7;
             const real_t elMat_5_8 = q_acc_5_8;
             const real_t elMat_5_9 = q_acc_5_9;
             const real_t elMat_5_10 = q_acc_5_10;
             const real_t elMat_5_11 = q_acc_5_11;
             const real_t elMat_6_0 = q_acc_0_6;
             const real_t elMat_6_1 = q_acc_1_6;
             const real_t elMat_6_2 = q_acc_2_6;
             const real_t elMat_6_3 = q_acc_3_6;
             const real_t elMat_6_4 = q_acc_4_6;
             const real_t elMat_6_5 = q_acc_5_6;
             const real_t elMat_6_6 = q_acc_6_6;
             const real_t elMat_6_7 = q_acc_6_7;
             const real_t elMat_6_8 = q_acc_6_8;
             const real_t elMat_6_9 = q_acc_6_9;
             const real_t elMat_6_10 = q_acc_6_10;
             const real_t elMat_6_11 = q_acc_6_11;
             const real_t elMat_7_0 = q_acc_0_7;
             const real_t elMat_7_1 = q_acc_1_7;
             const real_t elMat_7_2 = q_acc_2_7;
             const real_t elMat_7_3 = q_acc_3_7;
             const real_t elMat_7_4 = q_acc_4_7;
             const real_t elMat_7_5 = q_acc_5_7;
             const real_t elMat_7_6 = q_acc_6_7;
             const real_t elMat_7_7 = q_acc_7_7;
             const real_t elMat_7_8 = q_acc_7_8;
             const real_t elMat_7_9 = q_acc_7_9;
             const real_t elMat_7_10 = q_acc_7_10;
             const real_t elMat_7_11 = q_acc_7_11;
             const real_t elMat_8_0 = q_acc_0_8;
             const real_t elMat_8_1 = q_acc_1_8;
             const real_t elMat_8_2 = q_acc_2_8;
             const real_t elMat_8_3 = q_acc_3_8;
             const real_t elMat_8_4 = q_acc_4_8;
             const real_t elMat_8_5 = q_acc_5_8;
             const real_t elMat_8_6 = q_acc_6_8;
             const real_t elMat_8_7 = q_acc_7_8;
             const real_t elMat_8_8 = q_acc_8_8;
             const real_t elMat_8_9 = q_acc_8_9;
             const real_t elMat_8_10 = q_acc_8_10;
             const real_t elMat_8_11 = q_acc_8_11;
             const real_t elMat_9_0 = q_acc_0_9;
             const real_t elMat_9_1 = q_acc_1_9;
             const real_t elMat_9_2 = q_acc_2_9;
             const real_t elMat_9_3 = q_acc_3_9;
             const real_t elMat_9_4 = q_acc_4_9;
             const real_t elMat_9_5 = q_acc_5_9;
             const real_t elMat_9_6 = q_acc_6_9;
             const real_t elMat_9_7 = q_acc_7_9;
             const real_t elMat_9_8 = q_acc_8_9;
             const real_t elMat_9_9 = q_acc_9_9;
             const real_t elMat_9_10 = q_acc_9_10;
             const real_t elMat_9_11 = q_acc_9_11;
             const real_t elMat_10_0 = q_acc_0_10;
             const real_t elMat_10_1 = q_acc_1_10;
             const real_t elMat_10_2 = q_acc_2_10;
             const real_t elMat_10_3 = q_acc_3_10;
             const real_t elMat_10_4 = q_acc_4_10;
             const real_t elMat_10_5 = q_acc_5_10;
             const real_t elMat_10_6 = q_acc_6_10;
             const real_t elMat_10_7 = q_acc_7_10;
             const real_t elMat_10_8 = q_acc_8_10;
             const real_t elMat_10_9 = q_acc_9_10;
             const real_t elMat_10_10 = q_acc_10_10;
             const real_t elMat_10_11 = q_acc_10_11;
             const real_t elMat_11_0 = q_acc_0_11;
             const real_t elMat_11_1 = q_acc_1_11;
             const real_t elMat_11_2 = q_acc_2_11;
             const real_t elMat_11_3 = q_acc_3_11;
             const real_t elMat_11_4 = q_acc_4_11;
             const real_t elMat_11_5 = q_acc_5_11;
             const real_t elMat_11_6 = q_acc_6_11;
             const real_t elMat_11_7 = q_acc_7_11;
             const real_t elMat_11_8 = q_acc_8_11;
             const real_t elMat_11_9 = q_acc_9_11;
             const real_t elMat_11_10 = q_acc_10_11;
             const real_t elMat_11_11 = q_acc_11_11;
         
             std::vector< uint_t > _data_rowIdx( 12 );
             std::vector< uint_t > _data_colIdx( 12 );
             std::vector< real_t > _data_mat( 144 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dst_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dst_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_rowIdx[10] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_rowIdx[11] = ((uint64_t)(_data_dst_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[0] = ((uint64_t)(_data_src_vertex_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[2] = ((uint64_t)(_data_src_vertex_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src_edge_0[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[4] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_src_edge_0[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
             _data_colIdx[6] = ((uint64_t)(_data_src_vertex_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + 1]));
             _data_colIdx[7] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[8] = ((uint64_t)(_data_src_vertex_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 1]));
             _data_colIdx[9] = ((uint64_t)(_data_src_edge_1[ctr_0 + (ctr_1 + 1)*(micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2))]));
             _data_colIdx[10] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2)) + 1]));
             _data_colIdx[11] = ((uint64_t)(_data_src_edge_1[ctr_0 + ctr_1*(micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)) / (2))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((real_t)(elMat_0_0));
             _data_mat[1] = ((real_t)(elMat_0_1));
             _data_mat[2] = ((real_t)(elMat_0_2));
             _data_mat[3] = ((real_t)(elMat_0_3));
             _data_mat[4] = ((real_t)(elMat_0_4));
             _data_mat[5] = ((real_t)(elMat_0_5));
             _data_mat[6] = ((real_t)(elMat_0_6));
             _data_mat[7] = ((real_t)(elMat_0_7));
             _data_mat[8] = ((real_t)(elMat_0_8));
             _data_mat[9] = ((real_t)(elMat_0_9));
             _data_mat[10] = ((real_t)(elMat_0_10));
             _data_mat[11] = ((real_t)(elMat_0_11));
             _data_mat[12] = ((real_t)(elMat_1_0));
             _data_mat[13] = ((real_t)(elMat_1_1));
             _data_mat[14] = ((real_t)(elMat_1_2));
             _data_mat[15] = ((real_t)(elMat_1_3));
             _data_mat[16] = ((real_t)(elMat_1_4));
             _data_mat[17] = ((real_t)(elMat_1_5));
             _data_mat[18] = ((real_t)(elMat_1_6));
             _data_mat[19] = ((real_t)(elMat_1_7));
             _data_mat[20] = ((real_t)(elMat_1_8));
             _data_mat[21] = ((real_t)(elMat_1_9));
             _data_mat[22] = ((real_t)(elMat_1_10));
             _data_mat[23] = ((real_t)(elMat_1_11));
             _data_mat[24] = ((real_t)(elMat_2_0));
             _data_mat[25] = ((real_t)(elMat_2_1));
             _data_mat[26] = ((real_t)(elMat_2_2));
             _data_mat[27] = ((real_t)(elMat_2_3));
             _data_mat[28] = ((real_t)(elMat_2_4));
             _data_mat[29] = ((real_t)(elMat_2_5));
             _data_mat[30] = ((real_t)(elMat_2_6));
             _data_mat[31] = ((real_t)(elMat_2_7));
             _data_mat[32] = ((real_t)(elMat_2_8));
             _data_mat[33] = ((real_t)(elMat_2_9));
             _data_mat[34] = ((real_t)(elMat_2_10));
             _data_mat[35] = ((real_t)(elMat_2_11));
             _data_mat[36] = ((real_t)(elMat_3_0));
             _data_mat[37] = ((real_t)(elMat_3_1));
             _data_mat[38] = ((real_t)(elMat_3_2));
             _data_mat[39] = ((real_t)(elMat_3_3));
             _data_mat[40] = ((real_t)(elMat_3_4));
             _data_mat[41] = ((real_t)(elMat_3_5));
             _data_mat[42] = ((real_t)(elMat_3_6));
             _data_mat[43] = ((real_t)(elMat_3_7));
             _data_mat[44] = ((real_t)(elMat_3_8));
             _data_mat[45] = ((real_t)(elMat_3_9));
             _data_mat[46] = ((real_t)(elMat_3_10));
             _data_mat[47] = ((real_t)(elMat_3_11));
             _data_mat[48] = ((real_t)(elMat_4_0));
             _data_mat[49] = ((real_t)(elMat_4_1));
             _data_mat[50] = ((real_t)(elMat_4_2));
             _data_mat[51] = ((real_t)(elMat_4_3));
             _data_mat[52] = ((real_t)(elMat_4_4));
             _data_mat[53] = ((real_t)(elMat_4_5));
             _data_mat[54] = ((real_t)(elMat_4_6));
             _data_mat[55] = ((real_t)(elMat_4_7));
             _data_mat[56] = ((real_t)(elMat_4_8));
             _data_mat[57] = ((real_t)(elMat_4_9));
             _data_mat[58] = ((real_t)(elMat_4_10));
             _data_mat[59] = ((real_t)(elMat_4_11));
             _data_mat[60] = ((real_t)(elMat_5_0));
             _data_mat[61] = ((real_t)(elMat_5_1));
             _data_mat[62] = ((real_t)(elMat_5_2));
             _data_mat[63] = ((real_t)(elMat_5_3));
             _data_mat[64] = ((real_t)(elMat_5_4));
             _data_mat[65] = ((real_t)(elMat_5_5));
             _data_mat[66] = ((real_t)(elMat_5_6));
             _data_mat[67] = ((real_t)(elMat_5_7));
             _data_mat[68] = ((real_t)(elMat_5_8));
             _data_mat[69] = ((real_t)(elMat_5_9));
             _data_mat[70] = ((real_t)(elMat_5_10));
             _data_mat[71] = ((real_t)(elMat_5_11));
             _data_mat[72] = ((real_t)(elMat_6_0));
             _data_mat[73] = ((real_t)(elMat_6_1));
             _data_mat[74] = ((real_t)(elMat_6_2));
             _data_mat[75] = ((real_t)(elMat_6_3));
             _data_mat[76] = ((real_t)(elMat_6_4));
             _data_mat[77] = ((real_t)(elMat_6_5));
             _data_mat[78] = ((real_t)(elMat_6_6));
             _data_mat[79] = ((real_t)(elMat_6_7));
             _data_mat[80] = ((real_t)(elMat_6_8));
             _data_mat[81] = ((real_t)(elMat_6_9));
             _data_mat[82] = ((real_t)(elMat_6_10));
             _data_mat[83] = ((real_t)(elMat_6_11));
             _data_mat[84] = ((real_t)(elMat_7_0));
             _data_mat[85] = ((real_t)(elMat_7_1));
             _data_mat[86] = ((real_t)(elMat_7_2));
             _data_mat[87] = ((real_t)(elMat_7_3));
             _data_mat[88] = ((real_t)(elMat_7_4));
             _data_mat[89] = ((real_t)(elMat_7_5));
             _data_mat[90] = ((real_t)(elMat_7_6));
             _data_mat[91] = ((real_t)(elMat_7_7));
             _data_mat[92] = ((real_t)(elMat_7_8));
             _data_mat[93] = ((real_t)(elMat_7_9));
             _data_mat[94] = ((real_t)(elMat_7_10));
             _data_mat[95] = ((real_t)(elMat_7_11));
             _data_mat[96] = ((real_t)(elMat_8_0));
             _data_mat[97] = ((real_t)(elMat_8_1));
             _data_mat[98] = ((real_t)(elMat_8_2));
             _data_mat[99] = ((real_t)(elMat_8_3));
             _data_mat[100] = ((real_t)(elMat_8_4));
             _data_mat[101] = ((real_t)(elMat_8_5));
             _data_mat[102] = ((real_t)(elMat_8_6));
             _data_mat[103] = ((real_t)(elMat_8_7));
             _data_mat[104] = ((real_t)(elMat_8_8));
             _data_mat[105] = ((real_t)(elMat_8_9));
             _data_mat[106] = ((real_t)(elMat_8_10));
             _data_mat[107] = ((real_t)(elMat_8_11));
             _data_mat[108] = ((real_t)(elMat_9_0));
             _data_mat[109] = ((real_t)(elMat_9_1));
             _data_mat[110] = ((real_t)(elMat_9_2));
             _data_mat[111] = ((real_t)(elMat_9_3));
             _data_mat[112] = ((real_t)(elMat_9_4));
             _data_mat[113] = ((real_t)(elMat_9_5));
             _data_mat[114] = ((real_t)(elMat_9_6));
             _data_mat[115] = ((real_t)(elMat_9_7));
             _data_mat[116] = ((real_t)(elMat_9_8));
             _data_mat[117] = ((real_t)(elMat_9_9));
             _data_mat[118] = ((real_t)(elMat_9_10));
             _data_mat[119] = ((real_t)(elMat_9_11));
             _data_mat[120] = ((real_t)(elMat_10_0));
             _data_mat[121] = ((real_t)(elMat_10_1));
             _data_mat[122] = ((real_t)(elMat_10_2));
             _data_mat[123] = ((real_t)(elMat_10_3));
             _data_mat[124] = ((real_t)(elMat_10_4));
             _data_mat[125] = ((real_t)(elMat_10_5));
             _data_mat[126] = ((real_t)(elMat_10_6));
             _data_mat[127] = ((real_t)(elMat_10_7));
             _data_mat[128] = ((real_t)(elMat_10_8));
             _data_mat[129] = ((real_t)(elMat_10_9));
             _data_mat[130] = ((real_t)(elMat_10_10));
             _data_mat[131] = ((real_t)(elMat_10_11));
             _data_mat[132] = ((real_t)(elMat_11_0));
             _data_mat[133] = ((real_t)(elMat_11_1));
             _data_mat[134] = ((real_t)(elMat_11_2));
             _data_mat[135] = ((real_t)(elMat_11_3));
             _data_mat[136] = ((real_t)(elMat_11_4));
             _data_mat[137] = ((real_t)(elMat_11_5));
             _data_mat[138] = ((real_t)(elMat_11_6));
             _data_mat[139] = ((real_t)(elMat_11_7));
             _data_mat[140] = ((real_t)(elMat_11_8));
             _data_mat[141] = ((real_t)(elMat_11_9));
             _data_mat[142] = ((real_t)(elMat_11_10));
             _data_mat[143] = ((real_t)(elMat_11_11));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
